#!/bin/sh
#
#  This file is part of SSim, a simple discrete-event simulator.
#  See http://www.inf.usi.ch/carzaniga/ssim/
#  
#  Copyright (C) 2005 University of Colorado
#  
#  Authors: Antonio Carzaniga <firstname.lastname@usi.ch>
#           See AUTHORS for full details.
#  
#  SSim is free software: you can redistribute it and/or modify it under
#  the terms of the GNU General Public License as published by the Free
#  Software Foundation, either version 3 of the License, or (at your
#  option) any later version.
#  
#  SSim is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with SSim.  If not, see <http://www.gnu.org/licenses/>.
#
. $srcdir/config.sh
#
test_description "Compiling test program: tp..."
if ${MAKE:-make} tp; then
    test_passed_continue 
else
    test_failed 'could not compile tp'
    exit 1
fi
test_description "Testing TProcess..."
#
cleanup_files='test.out test.expected test.log'
#
cat > test.expected <<EOF
Program started
Simulation started
Consumer started
Consumer waiting for an event
Producer started
Producer waiting for an event
Producer signaling value 0
Producer waiting for an event
Consumer: at 100: 0
Consumer waiting for an event
Producer signaling value 1
Producer waiting for an event
Consumer: at 201: 1
Consumer waiting for an event
Producer signaling value 2
Producer waiting for an event
Consumer: at 303: 2
Consumer waiting for an event
Producer signaling value 3
Producer waiting for an event
Consumer: at 406: 3
Consumer waiting for an event
Producer signaling value 4
Producer waiting for an event
Consumer: at 510: 4
Consumer waiting for an event
Producer signaling value 5
Producer waiting for an event
Consumer: at 615: 5
Consumer waiting for an event
Producer signaling value 6
Producer waiting for an event
Consumer: at 721: 6
Consumer waiting for an event
Producer signaling value 7
Producer waiting for an event
Consumer: at 828: 7
Consumer waiting for an event
Producer signaling value 8
Producer waiting for an event
Consumer: at 936: 8
Consumer waiting for an event
Producer signaling value 9
Consumer: at 1045: 9
Consumer waiting for an event
Simulation ended
EOF
#
if ./tp > test.out && diff test.out test.expected
then
    test_passed
else
    test_failed 'see test.out, test.expected, and test.log for detail'
fi
